---
schema_version: "1"
id: 51d2fabfd657a593df0412f75f8b7241925845ae9042ba3b3fa8f4c5a1b33599
title: TMF621 v5 Trouble Ticket Management
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/industries-integrations/comms/references/generated-api-specs/tmf621v5.md
canonical_url: https://developer.salesforce.com/docs/industries/communications/references/tmf621v5
source_site: developer.salesforce.com
content_type: documentation
content_hash: 6b815d0bf32af0a63fd7bf1a5251ffa2aeb3504444d1f7bc4cdaaccd4928b2b6
products:
  - Communications Cloud TM Forum API
  - Industries Integrations
---
TMF621 v5 Trouble Ticket Management

# TMF621 v5 Trouble Ticket Management

The TMF621 API allows querying, creation and deletion of Trouble Tickets.

**Version:** v1

Protocols: https.

## Operations

### GET Get a List of Trouble Tickets

`GET /troubleticket`

Retrieves a list of Trouble Ticket entities. Attribute selection is enabled for first-level attributes - name,status,description,priority,ticketType.

#### Parameters

*   `fields` (query, string) fields for attribute selection. supported values- name,status,description,priority,ticketType
*   `status` (query, string) The current status of Case
*   `priority` (query, string) Priority of Case
*   `ticketType` (query, string) Specifies the Business Type of the case
*   `offset` (query, integer) Specifies the requested index for the start of the resources to be included in the response.
*   `pageLimit` (query, integer) Specifies the requested number of the resources to be included in the response.
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Version` (header, string, required) Specifies the version to use with the URL path. version should be greater than or equal to v62.0
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** successfully retrieved the trouble ticket list
    
    Media type: `application/json`. Schema: `array of trouble_ticket`.
    
    Array of `trouble_ticket`.
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: RECORD_NOT_FOUND
    reason: The specified resource ID doesn’t exist. Provide a valid resource ID and try again.
    ```
    

### POST Create a Trouble Ticket

`POST /troubleticket`

Creates a Trouble Ticket entity.

#### Parameters

*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Version` (header, string, required) Specifies the version to use with the URL path. version should be greater than or equal to v62.0
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Request body

Media type: `application/json`. Schema: `trouble_ticket_create`.

Specifies the Trouble Ticket to be created.

_Example_

```
{
    "name": "summer",
    "ticketType": "Electrical",
    "priority": "High",
    "description": "Case description for testing",
    "status": "Working",
    "severity": "Critical",
    "@type" : "troubleticket",
    "externalIdentifier": [
        {
            "id": "External001"
        }
    ],
    "channel": {
        "name": "Web",
        "id": "1"
    },
    "note": [
        {
            "author": "005xx000001X7q9AAC",
            "text": "CaseComment 1",
            "@type": "CaseComment"
        },
        {
            "author": "005xx000001X7q9AAC",
            "text": "CaseComment 2"
        }
    ],
    "troubleTicketRelationship": [
        {
            "id": "00001002"
        }
    ],
    "relatedParty": [
        {
            "role": "Customer - Direct",
            "partyOrPartyRole": {
                "id" : "001xx000003GYiGAAW",
                "name": "United Oil &amp; Gas Corp.",
                "@type": "PartyRef",
                "@referredType": "Account"
            },
            "@type": "RelatedPartyRefOrPartyRoleRef"
        },
        {
            "role": "Contact",
            "partyOrPartyRole": {
                "id" : "003xx000004WhFoAAK",
                "name": "Rosa",
                "@type": "PartyRef",
                "@referredType": "Contact"
            },
            "@type": "RelatedPartyRefOrPartyRoleRef"
        }
    ],
    "relatedEntity": [
        {
        "role": "Asset",
        "@type": "RelatedEntity",
        "entity":{
            "id": "02ixx0000004HHiAAM",
            "name": "test asset",
            "@type": "EntityRef",
            "@referredType": "Asset"
            }
        }
    ],
    "attachment": [
        {
            "description": "Scanned disputed bill",
            "attachmentType": "billCopy",
            "mimeType": "image/png",
            "name": "March Bill",
            "url": "https://mycsp.com:7070/docloader?docnum=3534555",
            "@type": "AttachmentRef"
        }
    ]
}
```

#### Responses

*   **201** Created the Trouble Ticket resource.
    
    Media type: `application/json`. Schema: `trouble_ticket`.
    
    _Example_
    
    ```
    {
        "id": "00001094",
        "href": "/connect/comms/troubleticket/v5/troubleticket/00001094",
        "name": "summer",
        "ticketType": "Electrical",
        "priority": "High",
        "description": "Case description for testing",
        "status": "Working",
        "@type": "TroubleTicket",
        "severity": "Critical",
        "creationDate": "Mon Jul 15 06:56:23 GMT 2024",
        "lastUpdate": "Mon Jul 15 06:56:23 GMT 2024",
        "externalIdentifier": [
            {
                "id": "External001",
                "@type": "ExternalIdentifier"
            }
        ],
        "channel": {
            "name": "Web",
            "id": "1",
            "@type": "ChannelRef"
        },
        "note": [
            {
                "author": "005xx000001X7q9AAC",
                "text": "CaseComment 1",
                "@type": "CaseComment"
            },
            {
                "author": "005xx000001X7q9AAC",
                "text": "CaseComment 2",
                "@type": "CaseComment"
            }
        ],
        "troubleTicketRelationship": [
            {
                "id": "00001002",
                "href": "/connect/comms/troubleticket/v5/troubleticket/00001002",
                "name": "Seeking guidance on electrical wiring installation for GC5060",
                "relationshipType": "Parent",
                "@type": "TroubleTicketRelationship"
            }
        ],
        "relatedParty": [
            {
                "role": "Customer - Direct",
                "partyOrPartyRole": {
                    "id": "001xx000003GYiGAAW",
                    "href": "/services/data/v60.0/sobjects/Account/001xx000003GYiGAAW",
                    "name": "United Oil &amp; Gas Corp.",
                    "@type": "PartyRef",
                    "@referredType": "Account"
                },
                "@type": "RelatedPartyRefOrPartyRoleRef"
            },
            {
                "role": "Contact",
                "partyOrPartyRole": {
                    "id": "003xx000004WhFoAAK",
                    "href": "/services/data/v60.0/sobjects/Contact/003xx000004WhFoAAK",
                    "name": "Rose Gonzalez",
                    "@type": "PartyRef",
                    "@referredType": "Contact"
                },
                "@type": "RelatedPartyRefOrPartyRoleRef"
            }
        ],
        "relatedEntity": [
            {
                "role": "Asset",
                "@type": "RelatedEntity",
                "entity": {
                    "id": "02ixx0000004HHiAAM",
                    "href": "/services/data/v60.0/sobjects/Asset/02ixx0000004HHiAAM",
                    "name": "Test Asset",
                    "@type": "EntityRef",
                    "@referredType": "Asset"
                }
            }
        ],
        "attachment": [
            {
                "name": "March Bill",
                "id": "069xx0000004DBYAA2",
                "description": "Scanned disputed bill",
                "attachmentType": "LINK",
                "mimeType": "MimeType",
                "url": "https://mycsp.com:7070/docloader?docnum=3534555",
                "@type": "AttachmentRef"
            }
        ]
    }
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: RECORD_NOT_FOUND
    reason: The specified resource ID doesn’t exist. Provide a valid resource ID and try again.
    ```
    

### GET Retrieve a Trouble Ticket

`GET /troubleticket/{id}`

Retrieves a Trouble Ticket entity by id.

#### Parameters

*   `id` (path, string, required)
*   `fields` (query, string) fields for attribute selection. supported values- name,status,description,priority,ticketType
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Version` (header, string, required) Specifies the version to use with the URL path. version should be greater than or equal to v62.0
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **200** Success
    
    Media type: `application/json`. Schema: `trouble_ticket`.
    
    _Example_
    
    ```
    {
        "id": "00001002",
        "href": "/connect/comms/troubleticket/v5/troubleticket/00001002",
        "name": "Seeking guidance on electrical wiring installation for GC5060",
        "ticketType": "Electrical",
        "priority": "High",
        "description": "Case description for testing",
        "status": "Working",
        "@type": "TroubleTicket",
        "severity": "Major",
        "creationDate": "Wed Jul 10 15:58:07 GMT 2024",
        "lastUpdate": "Thu Jul 11 12:16:28 GMT 2024",
        "externalIdentifier": [
            {
                "id": "External001",
                "@type": "ExternalIdentifier"
            }
        ],
        "channel": {
            "name": "Web",
            "id": "1",
            "@type": "ChannelRef"
        },
        "statusChangeHistory": [
            {
                "status": "Working",
                "statusChangeDate": "Thu Jul 11 08:30:59 GMT 2024",
                "@type": "StatusChange"
            }
        ],
        "note": [
            {
                "author": "005xx000001X7q9AAC",
                "text": "CaseComment 1",
                "@type": "CaseComment"
            },
            {
                "author": "005xx000001X7q9AAC",
                "text": "CaseComment 2",
                "@type": "CaseComment"
            }
        ],
        "troubleTicketRelationship": [
            {
                "id": "00001000",
                "href": "/connect/comms/troubleticket/v5/troubleticket/00001000",
                "name": "Starting generator after electrical failure",
                "relationshipType": "Parent",
                "@type": "TroubleTicketRelationship"
            }
        ],
        "relatedParty": [
            {
                "role": "Customer - Direct",
                "partyOrPartyRole": {
                    "id": "001xx000003GYiGAAW",
                    "href": "/services/data/v60.0/sobjects/Account/001xx000003GYiGAAW",
                    "name": "United Oil &amp; Gas Corp.",
                    "@type": "PartyRef",
                    "@referredType": "Account"
                },
                "@type": "RelatedPartyRefOrPartyRoleRef"
            },
            {
                "role": "Contact",
                "partyOrPartyRole": {
                    "id": "003xx000004WhFvAAK",
                    "href": "/services/data/v60.0/sobjects/Contact/003xx000004WhFvAAK",
                    "name": "Stella Pavlova",
                    "@type": "PartyRef",
                    "@referredType": "Contact"
                },
                "@type": "RelatedPartyRefOrPartyRoleRef"
            }
        ],
        "relatedEntity": [
            {
                "role": "Asset",
                "@type": "RelatedEntity",
                "entity": {
                    "id": "02ixx0000004HHiAAM",
                    "href": "/services/data/v60.0/sobjects/Asset/02ixx0000004HHiAAM",
                    "name": "Test Asset",
                    "@type": "EntityRef",
                    "@referredType": "Asset"
                }
            }
        ],
        "attachment": [
            {
                "name": "export",
                "id": "069xx0000004C92AAE",
                "description": "sample description",
                "attachmentType": "JSON",
                "mimeType": "MimeType",
                "url": "url",
                "@type": "AttachmentRef"
            }
        ]
    }
    ```
    
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: RECORD_NOT_FOUND
    reason: The specified resource ID doesn’t exist. Provide a valid resource ID and try again.
    ```
    

### DELETE Delete a Trouble Ticket

`DELETE /troubleticket/{id}`

This operation allows deletion of a Trouble Ticket by id.

#### Parameters

*   `id` (path, string, required)
*   `Authorization` (header, string, required) Specifies the bearer token to use for the authentication of request.
*   `Version` (header, string, required) Specifies the version to use with the URL path. version should be greater than or equal to v62.0
*   `Domain-Name` (header, string, required) Specifies the domain name to use with the URL path received from the userinfo API.

#### Responses

*   **204**
*   **404** Resource not found.
    
    Media type: `application/json`. Schema: `Error`.
    
    _Example_
    
    ```
    code: RECORD_NOT_FOUND
    reason: The specified resource ID doesn’t exist. Provide a valid resource ID and try again.
    ```
    

## Schemas

### trouble\_ticket

Trouble Ticket object

*   `href` (_string_, required) URI of the Case
*   `id` (_string_, required) Unique identifier of the Salesforce Case record (CaseNumber)
*   `name` (_string_) Subject of the Case
*   `@type` (_string_, required) Type of the TMF Entity e.g. TroubleTicket
*   `description` (_string_, required) Description of the Case
*   `severity` (_string_, required) Custom Picklist value specifiing case severity. Sample value include Critical, Major, Minor.
*   `ticketType` (_string_, required) Specifies the Business Type of the case
*   `priority` (_string_) Specifies Priority of Case
*   `status` (_string_) The current status of case
*   `creationDate` (_string_) Case created Date
*   `lastUpdate` (_string_) Case Last Modified Date
*   `resolutionDate` (_string_) Case Resolution Date
*   `statusChangeDate` (_string_) Latest case status change date
*   `expectedResolutionDate` (_string_) The Expected Resolution Date of CaseTroubleTicket
*   `requestedResolutionDate` (_string_) The Requested Resolution Date of CaseTroubleTicket
*   `statusChangeHistory` (_array of object_) A List of status the case assumed till date
    
    Includes all fields of `statusChangeHistoryRef`.
    
*   `attachment` (_array of object_) Specifies the Attachment(s) associated with Case
    
    Includes all fields of `attachmentRef`.
    
*   `relatedParty` (_array of object_) Account/Contact associated with Case
    
    Includes all fields of `relatedPartyRef`.
    
*   `channel` (_object_) Specifies Case Origin
    
    Includes all fields of `channelRef`.
    
*   `note` (_array of object_) Comment(s) associated with the case
    
    Includes all fields of `noteRef`.
    
*   `relatedEntity` (_array of object_) Product or Asset related to the case
    
    Includes all fields of `relatedEntityRef`.
    
*   `troubleTicketRelationship` (_array of object_) Specifies related Parent Case
    
    Includes all fields of `troubleTicketRelationshipRef`.
    
*   `externalIdentifier` (_array of object_) External Id associated with CaseTroubleTicket
    
    Includes all fields of `externalIdentifierRef`.
    

### Error

Shown when an API throws an error, typically with an HTTP error response code (3xx, 4xx, or 5xx).

*   `code` (_string_, required) Specifies the application-relevant detail defined in the API or a common list.
*   `reason` (_string_, required) Describes the reason for the error, which can be shown to a client user.

### trouble\_ticket\_create

Trouble Ticket creation object

*   `name` (_string_) Subject of the Case
*   `description` (_string_, required) Description of the Case
*   `severity` (_string_, required) Custom Picklist value specifing case severity. Sample value include Critical, Major, Minor.
*   `ticketType` (_string_, required) Specifies the Business Type of the case. The values passed in post payload must be defined as one of the picklist value.
*   `priority` (_string_) Specifies Priority of Case. The values passed in post payload must be defined as one of the picklist value.
*   `status` (_string_) The current status of Case. The values passed in post payload must be defined as one of the picklist value.
*   `expectedResolutionDate` (_string_) The Expected Resolution Date of CaseTroubleTicket
*   `requestedResolutionDate` (_string_) The Requested Resolution Date of CaseTroubleTicket
*   `attachment` (_array of object_) Attachment(s) associated with the case
    
    Includes all fields of `attachmentRef_create`.
    
*   `relatedParty` (_array of object_) Acount or Contact related to the Case
    
    Includes all fields of `relatedPartyRef_create`.
    
*   `channel` (_object_) Specifies Case Origin
    
    Includes all fields of `channelRef_create`.
    
*   `note` (_array of object_) Comment(s) associated with the case
    
    Includes all fields of `noteRef_create`.
    
*   `relatedEntity` (_array of object_) Product or Asset related to the case
    
    Includes all fields of `relatedEntityRef_create`.
    
*   `troubleTicketRelationship` (_array of object_) Specifies related Parent Case
    
    Includes all fields of `troubleTicketRelationshipRef_create`.
    
*   `externalIdentifier` (_array of object_) External Id associated with CaseTroubleTicket
    
    Includes all fields of `externalIdentifierRef_create`.
    

### statusChangeHistoryRef

*   `status` (_string_) Status of the troubleticket
*   `statusChangeDate` (_string_) Date when the status changed from previous to current value
*   `@type` (_string_, required) String value of 'StatusChange'

### attachmentRef

*   `id` (_string_, required) Unique identifier for Content Version
*   `attachmentType` (_string_, required) FileType for the content uploaded
*   `url` (_string_) Url of the content
*   `mimeType` (_string_, required) Will have static value of MimeType
*   `name` (_string_) Title of the Content Version
*   `@type` (_string_, required) String value 'AttachmentRef'
*   `description` (_string_) Description of the Content Version

### relatedPartyRef

*   `role` (_string_, required) Value should be Account.Type or Contact
*   `@type` (_string_, required) Value should be RelatedPartyRefOrPartyRoleRef
*   `partyOrPartyRole` (_object_) Id and name of relatedParty
    
    Includes all fields of `partyOrPartyRoleRef`.
    

### channelRef

*   `id` (_string_, required) Unique identifier of the Channel
*   `name` (_string_) Origin of Case
*   `@type` (_string_, required) Describes the relation to this entity. Only value supported is Parent

### noteRef

*   `text` (_string_) Content of the comment
*   `author` (_string_) Author of the CaseComment
*   `@type` (_string_, required) String value 'CaseComment'
*   `date` (_string_) Comment created Date
*   `id` (_string_) Unique identification of CaseComment

### relatedEntityRef

*   `role` (_string_, required) The role of an entity
*   `@type` (_string_, required) Value of 'RelatedEntity'
*   `entity` (_object_, required) Product or Asset
    
    Includes all fields of `entityRef`.
    

### troubleTicketRelationshipRef

*   `id` (_string_, required) Unique identifier of the Parent Case
*   `relationshipType` (_string_, required) Describes the relation to this entity. Only value supported is Parent
*   `@type` (_string_, required) String value 'TroubleTicketRelationship'
*   `href` (_string_) sObject identifer
*   `name` (_string_) Subject of the Parent Case

### externalIdentifierRef

*   `id` (_string_, required) ExternalId of CaseTroubleTicket
*   `@type` (_string_, required) String value of 'ExternalIdentifier'

### attachmentRef\_create

*   `url` (_string_, required) Url of the content
*   `mimeType` (_string_) Will have static value of MimeType
*   `name` (_string_, required) Title of the Content Version
*   `@type` (_string_) String value 'AttachmentRef'
*   `description` (_string_, required) Description of the Content Version
*   `attachmentType` (_string_) FileType for the content uploaded

### relatedPartyRef\_create

*   `role` (_string_, required) Value should be Account.Type or Contact
*   `@type` (_string_, required) Value should be RelatedPartyRef Or PartyRoleRef
*   `partyOrPartyRole` (_object_) Id and name of relatedParty
    
    Includes all fields of `partyOrPartyRoleRef_create`.
    

### channelRef\_create

*   `id` (_string_, required) Unique identifier of the Channel
*   `name` (_string_) Origin of Case
*   `@type` (_string_) Describes the relation to this entity. Only value supported is Parent

### noteRef\_create

*   `text` (_string_, required) Content of the comment
*   `author` (_string_) Author of the CaseComment
*   `@type` (_string_) String value 'CaseComment'

### relatedEntityRef\_create

*   `role` (_string_, required) The role of an entity
*   `@type` (_string_, required) Value of 'RelatedEntity'
*   `entity` (_object_, required) Product or Asset
    
    Includes all fields of `entityRef_create`.
    

### troubleTicketRelationshipRef\_create

*   `id` (_string_, required) Unique identifier of the Parent Case
*   `relationshipType` (_string_) Describes the relation to this entity. Only value supported is Parent
*   `@type` (_string_) String value 'TroubleTicketRelationship'

### externalIdentifierRef\_create

*   `id` (_string_, required) ExternalId of CaseTroubleTicket
*   `@type` (_string_) String value of 'ExternalIdentifier'

### partyOrPartyRoleRef

*   `id` (_string_, required) Unique identification of Account or Contact
*   `name` (_string_) Name of Account or Contact
*   `@type` (_string_, required) Value of PartyRef
*   `@referredType` (_string_) Value should be 'Account' or 'Contact'
*   `href` (_string_) Href of Account or Contact

### entityRef

*   `id` (_string_, required) Unique idenfication of an Asset
*   `name` (_string_) Name of Product or Asset
*   `@type` (_string_, required) Value of 'EntityRef'
*   `@referredType` (_string_) Specifies if the RelatedEntity is Asset or Disputedbill

### partyOrPartyRoleRef\_create

*   `id` (_string_, required) Unique identification of Account or Contact
*   `name` (_string_) Name of Account or Contact
*   `@type` (_string_) Value of PartyRef
*   `@referredType` (_string_, required) Value should be 'Account' or 'Contact'

### entityRef\_create

*   `id` (_string_, required) Unique idenfication of an Asset
*   `name` (_string_) Name of Product or Asset
*   `@type` (_string_) Value of 'EntityRef'
*   `@referredType` (_string_, required) Specifies if the RelatedEntity is Asset or Disputedbill